<template>
  <b-autocomplete rounded
                  v-model="gameSearch"
                  :data="gamesFiltered"
                  field="name"
                  :placeholder="$t('games.search')"
                  icon="search"
                  clearable
                  @select="navigate">
    <template slot-scope="props">
      <div class="media">
        <div class="media-left">
          <img width="50"
               :src="imageName(props.option.name)" />
        </div>
          {{ props.option.name }}
      </div>
    </template>
    </b-autocomplete>

</template>

<script lang="ts">
import { Component, Vue, Prop } from 'vue-property-decorator';
import { MapState } from '@/decorators';
import { isEmpty } from 'lodash';
import { SET_GAMES } from '@/store';
import { GameName, Game } from '@/types/games';
import GameMixin from '@/mixins/game.vue';

@Component
export default class GameSearch extends GameMixin {
  @MapState(['games'])
  @Prop(String) readonly link: string;
  gameSearch: string = '';

  async mounted() {
    if(!isEmpty((this as any).games)) {
      return;
    }
    const { data } = await this.$http.get('games/all');
    this.$store.commit(SET_GAMES, data);
  }

  get gamesFiltered(): GameName[] {
    const search = this.gameSearch.toLowerCase();
    return (this as any).games.filter((game: Game) => {
      return (game.name as string)
              .toLowerCase()
              .includes(search);
    });
  }

  navigate(selected: Game) {
    this.$router.push({
      name: this.link,
      params: { id: String(selected.id) },
    });
  }
}
</script>
